diff --git a/python/pyasn1-modules/tools/ocsprspdump.py b/python/pyasn1-modules/tools/ocsprspdump.py
index 9e49ce038d..562d563705 100755
--- a/python/pyasn1-modules/tools/ocsprspdump.py
+++ b/python/pyasn1-modules/tools/ocsprspdump.py
@@ -3,13 +3,14 @@
 # Read ASN.1/PEM OCSP response on stdin, parse into
 # plain text, then build substrate from it
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2560, pem
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat ocsp-response.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat ocsp-response.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 ocspReq = rfc2560.OCSPResponse()
@@ -20,7 +21,7 @@ if not substrate:
         
 cr, rest = decoder.decode(substrate, asn1Spec=ocspReq)
 
-print(cr.prettyPrint())
+print((cr.prettyPrint()))
 
 assert encoder.encode(cr, defMode=False) == substrate or \
        encoder.encode(cr, defMode=True) == substrate, \
diff --git a/python/pyasn1-modules/tools/ocspserver.py b/python/pyasn1-modules/tools/ocspserver.py
index 2d12d53998..e862720f67 100755
--- a/python/pyasn1-modules/tools/ocspserver.py
+++ b/python/pyasn1-modules/tools/ocspserver.py
@@ -1,11 +1,12 @@
 #!/usr/bin/python
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2560, rfc2459, pem
 from pyasn1.type import univ
 import sys, hashlib
 try:
-    import urllib2
+    import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 except ImportError:
     import urllib.request as urllib2
 
@@ -33,7 +34,7 @@ def mkOcspRequest(issuerCert, userCert):
     userTbsCertificate = userCert.getComponentByName('tbsCertificate')
     userIssuer = userTbsCertificate.getComponentByName('issuer')
 
-    assert issuerSubject == userIssuer, '%s\n%s' % (
+    assert issuerSubject == userIssuer, '{}\n{}'.format(
         issuerSubject.prettyPrint(), userIssuer.prettyPrint()
         )
 
@@ -98,8 +99,8 @@ def parseOcspRequest(ocspRequest):
         )
 
 if len(sys.argv) != 2:
-    print("""Usage:
-$ cat CACertificate.pem userCertificate.pem | %s <ocsp-responder-url>""" % sys.argv[0])
+    print(("""Usage:
+$ cat CACertificate.pem userCertificate.pem | %s <ocsp-responder-url>""" % sys.argv[0]))
     sys.exit(-1)
 else:
     ocspUrl = sys.argv[1]
@@ -122,12 +123,12 @@ ocspReq = mkOcspRequest(issuerCert, userCert)
 # Use HTTP POST to get response (see Appendix A of RFC 2560)
 # In case you need proxies, set the http_proxy env variable
 
-httpReq = urllib2.Request(
+httpReq = six.moves.urllib.request.Request(
     ocspUrl,
     encoder.encode(ocspReq),
     { 'Content-Type': 'application/ocsp-request' }
     )
-httpRsp = urllib2.urlopen(httpReq).read()
+httpRsp = six.moves.urllib.request.urlopen(httpReq).read()
 
 # Process OCSP response
     
@@ -135,9 +136,9 @@ ocspRsp, _ = decoder.decode(httpRsp, asn1Spec=rfc2560.OCSPResponse())
 
 producedAt, certId, certStatus, thisUpdate = parseOcspResponse(ocspRsp)
 
-print('Certificate ID %s is %s at %s till %s\n' % (
+print(('Certificate ID {} is {} at {} till {}\n'.format(
     certId.getComponentByName('serialNumber'),
     certStatus,
     producedAt,
     thisUpdate
-    ))
+    )))
diff --git a/python/pyasn1-modules/tools/pkcs10dump.py b/python/pyasn1-modules/tools/pkcs10dump.py
index ea979c0cf5..976d5c0e76 100755
--- a/python/pyasn1-modules/tools/pkcs10dump.py
+++ b/python/pyasn1-modules/tools/pkcs10dump.py
@@ -3,13 +3,14 @@
 # Read ASN.1/PEM X.509 certificate requests (PKCS#10 format) on stdin, 
 # parse each into plain text, then build substrate from it
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2314, pem
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat certificateRequest.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat certificateRequest.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 certType = rfc2314.CertificationRequest()
@@ -28,7 +29,7 @@ while 1:
 
     if rest: substrate = substrate[:-len(rest)]
         
-    print(cert.prettyPrint())
+    print((cert.prettyPrint()))
 
     assert encoder.encode(cert, defMode=False) == substrate or \
            encoder.encode(cert, defMode=True) == substrate, \
@@ -36,4 +37,4 @@ while 1:
         
     certCnt = certCnt + 1
     
-print('*** %s PEM certificate request(s) de/serialized' % certCnt)
+print(('*** %s PEM certificate request(s) de/serialized' % certCnt))
diff --git a/python/pyasn1-modules/tools/pkcs1dump.py b/python/pyasn1-modules/tools/pkcs1dump.py
index d0da82b2fb..ff350c1076 100755
--- a/python/pyasn1-modules/tools/pkcs1dump.py
+++ b/python/pyasn1-modules/tools/pkcs1dump.py
@@ -4,13 +4,14 @@
 # stdin, print them pretty and encode back into original wire format.
 # Private keys can be generated with "openssl genrsa|gendsa" commands.
 #
+from __future__ import print_function
 from pyasn1_modules import rfc2459, rfc2437, pem
 from pyasn1.codec.der import encoder, decoder
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat rsakey.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat rsakey.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 cnt = 0
@@ -31,7 +32,7 @@ while 1:
 
     if rest: substrate = substrate[:-len(rest)]
         
-    print(key.prettyPrint())
+    print((key.prettyPrint()))
 
     assert encoder.encode(key, defMode=False) == substrate or \
            encoder.encode(key, defMode=True) == substrate, \
@@ -39,4 +40,4 @@ while 1:
         
     cnt = cnt + 1
  
-print('*** %s key(s) re/serialized' % cnt)
+print(('*** %s key(s) re/serialized' % cnt))
diff --git a/python/pyasn1-modules/tools/pkcs7dump.py b/python/pyasn1-modules/tools/pkcs7dump.py
index 7794871620..e47ba940c3 100755
--- a/python/pyasn1-modules/tools/pkcs7dump.py
+++ b/python/pyasn1-modules/tools/pkcs7dump.py
@@ -3,13 +3,14 @@
 # Read ASN.1/PEM PKCS#7 on stdin, parse it into plain text,
 # then build substrate from it
 #
+from __future__ import print_function
 from pyasn1_modules import rfc2315, pem
 from pyasn1.codec.der import encoder, decoder
 import sys
     
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat pkcs7Certificate.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat pkcs7Certificate.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 idx, substrate = pem.readPemBlocksFromFile(
@@ -22,7 +23,7 @@ contentInfo, rest = decoder.decode(substrate, asn1Spec=rfc2315.ContentInfo())
 
 if rest: substrate = substrate[:-len(rest)]
     
-print(contentInfo.prettyPrint())
+print((contentInfo.prettyPrint()))
 
 assert encoder.encode(contentInfo, defMode=False) == substrate or \
        encoder.encode(contentInfo, defMode=True) == substrate, \
@@ -44,4 +45,4 @@ content, _ = decoder.decode(
     asn1Spec=contentInfoMap[contentType]
     )
 
-print(content.prettyPrint())
+print((content.prettyPrint()))
diff --git a/python/pyasn1-modules/tools/pkcs8dump.py b/python/pyasn1-modules/tools/pkcs8dump.py
index d1d125f8cc..fa82a57d45 100755
--- a/python/pyasn1-modules/tools/pkcs8dump.py
+++ b/python/pyasn1-modules/tools/pkcs8dump.py
@@ -3,13 +3,14 @@
 # Read  bunch of ASN.1/PEM plain/encrypted private keys in PKCS#8 
 # format on stdin, parse each into plain text, then build substrate from it
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc5208, pem
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat pkcs8key.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat pkcs8key.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 cnt = 0
@@ -30,7 +31,7 @@ while 1:
 
     if rest: substrate = substrate[:-len(rest)]
         
-    print(key.prettyPrint())
+    print((key.prettyPrint()))
 
     assert encoder.encode(key, defMode=False) == substrate or \
            encoder.encode(key, defMode=True) == substrate, \
@@ -38,4 +39,4 @@ while 1:
         
     cnt = cnt + 1
     
-print('*** %s PKCS#8 key(s) de/serialized' % cnt)
+print(('*** %s PKCS#8 key(s) de/serialized' % cnt))
diff --git a/python/pyasn1-modules/tools/snmpget.py b/python/pyasn1-modules/tools/snmpget.py
index 372510329b..394bfd4eff 100755
--- a/python/pyasn1-modules/tools/snmpget.py
+++ b/python/pyasn1-modules/tools/snmpget.py
@@ -2,13 +2,14 @@
 #
 # Generate SNMPGET request, parse response
 #
+from __future__ import print_function
 from pyasn1.codec.ber import encoder, decoder
 from pyasn1_modules import rfc1157
 import sys, socket
 
 if len(sys.argv) != 4:
-    print("""Usage:
-$ %s <community> <host> <OID>""" % sys.argv[0])
+    print(("""Usage:
+$ %s <community> <host> <OID>""" % sys.argv[0]))
     sys.exit(-1)
 
 msg = rfc1157.Message()
@@ -25,7 +26,7 @@ vb = vbl.setComponentByPosition(0).getComponentByPosition(0)
 vb.setComponentByPosition(0, sys.argv[3])
 v = vb.setComponentByPosition(1).getComponentByPosition(1).setComponentByPosition(0).getComponentByPosition(0).setComponentByPosition(3).getComponentByPosition(3)
 
-print('sending: %s' % msg.prettyPrint())
+print(('sending: %s' % msg.prettyPrint()))
 
 sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
 sock.sendto(encoder.encode(msg), (sys.argv[2], 161))
@@ -34,4 +35,4 @@ substrate, _ = sock.recvfrom(2048)
 
 rMsg, _ = decoder.decode(substrate, asn1Spec=msg)
 
-print('received: %s' % rMsg.prettyPrint())
+print(('received: %s' % rMsg.prettyPrint()))
diff --git a/python/pyasn1-modules/tools/x509dump.py b/python/pyasn1-modules/tools/x509dump.py
index 64cba7e305..d95206fa74 100755
--- a/python/pyasn1-modules/tools/x509dump.py
+++ b/python/pyasn1-modules/tools/x509dump.py
@@ -3,14 +3,15 @@
 # Read ASN.1/PEM X.509 certificates on stdin, parse each into plain text,
 # then build substrate from it
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2459, pem
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat CACertificate.pem | %s
-$ cat userCertificate.pem | %s""" % (sys.argv[0], sys.argv[0]))
+    print(("""Usage:
+$ cat CACertificate.pem | {}
+$ cat userCertificate.pem | {}""".format(sys.argv[0], sys.argv[0])))
     sys.exit(-1)
     
 certType = rfc2459.Certificate()
@@ -29,7 +30,7 @@ while 1:
 
     if rest: substrate = substrate[:-len(rest)]
         
-    print(cert.prettyPrint())
+    print((cert.prettyPrint()))
 
     assert encoder.encode(cert, defMode=False) == substrate or \
            encoder.encode(cert, defMode=True) == substrate, \
@@ -37,4 +38,4 @@ while 1:
         
     certCnt = certCnt + 1
     
-print('*** %s PEM cert(s) de/serialized' % certCnt)
+print(('*** %s PEM cert(s) de/serialized' % certCnt))
diff --git a/python/pyasn1/pyasn1/codec/ber/decoder.py b/python/pyasn1/pyasn1/codec/ber/decoder.py
index be0cf49074..abddc95dee 100644
--- a/python/pyasn1/pyasn1/codec/ber/decoder.py
+++ b/python/pyasn1/pyasn1/codec/ber/decoder.py
@@ -8,17 +8,17 @@ class AbstractDecoder:
     protoComponent = None
     def valueDecoder(self, fullSubstrate, substrate, asn1Spec, tagSet,
                      length, state, decodeFun, substrateFun):
-        raise error.PyAsn1Error('Decoder not implemented for %s' % (tagSet,))
+        raise error.PyAsn1Error('Decoder not implemented for {}'.format(tagSet))
 
     def indefLenValueDecoder(self, fullSubstrate, substrate, asn1Spec, tagSet,
                      length, state, decodeFun, substrateFun):
-        raise error.PyAsn1Error('Indefinite length mode decoder not implemented for %s' % (tagSet,))
+        raise error.PyAsn1Error('Indefinite length mode decoder not implemented for {}'.format(tagSet))
 
 class AbstractSimpleDecoder(AbstractDecoder):
     tagFormats = (tag.tagFormatSimple,)
     def _createComponent(self, asn1Spec, tagSet, value=None):
         if tagSet[0][1] not in self.tagFormats:
-            raise error.PyAsn1Error('Invalid tag format %r for %r' % (tagSet[0], self.protoComponent,))
+            raise error.PyAsn1Error('Invalid tag format {!r} for {!r}'.format(tagSet[0], self.protoComponent))
         if asn1Spec is None:
             return self.protoComponent.clone(value, tagSet)
         elif value is None:
@@ -30,7 +30,7 @@ class AbstractConstructedDecoder(AbstractDecoder):
     tagFormats = (tag.tagFormatConstructed,)
     def _createComponent(self, asn1Spec, tagSet, value=None):
         if tagSet[0][1] not in self.tagFormats:
-            raise error.PyAsn1Error('Invalid tag format %r for %r' % (tagSet[0], self.protoComponent,))
+            raise error.PyAsn1Error('Invalid tag format {!r} for {!r}'.format(tagSet[0], self.protoComponent))
         if asn1Spec is None:
             return self.protoComponent.clone(tagSet)
         else:
@@ -238,7 +238,7 @@ class ObjectIdentifierDecoder(AbstractSimpleDecoder):
                     subId = (subId << 7) + (nextSubId & 0x7F)
                     if index >= substrateLen:
                         raise error.SubstrateUnderrunError(
-                            'Short substrate for sub-OID past %s' % (oid,)
+                            'Short substrate for sub-OID past {}'.format(oid)
                             )
                     nextSubId = oct2int(head[index])
                     index = index + 1
@@ -568,7 +568,7 @@ typeMap = {
 
 ( stDecodeTag, stDecodeLength, stGetValueDecoder, stGetValueDecoderByAsn1Spec,
   stGetValueDecoderByTag, stTryAsExplicitTag, stDecodeValue,
-  stDumpRawValue, stErrorCondition, stStop ) = [x for x in range(10)]
+  stDumpRawValue, stErrorCondition, stStop ) = (x for x in range(10))
 
 class Decoder:
     defaultErrorState = stErrorCondition
@@ -711,7 +711,7 @@ class Decoder:
                     else:
                         state = stTryAsExplicitTag
                 if debug.logger and debug.logger & debug.flagDecoder:
-                    debug.logger('codec %s chosen by a built-in type, decoding %s' % (concreteDecoder and concreteDecoder.__class__.__name__ or "<none>", state == stDecodeValue and 'value' or 'as explicit tag'))
+                    debug.logger('codec {} chosen by a built-in type, decoding {}'.format(concreteDecoder and concreteDecoder.__class__.__name__ or "<none>", state == stDecodeValue and 'value' or 'as explicit tag'))
                     debug.scope.push(concreteDecoder is None and '?' or concreteDecoder.protoComponent.__class__.__name__)
             if state == stGetValueDecoderByAsn1Spec:
                 if isinstance(asn1Spec, (dict, tagmap.TagMap)):
@@ -722,12 +722,12 @@ class Decoder:
                     if debug.logger and debug.logger & debug.flagDecoder:
                         debug.logger('candidate ASN.1 spec is a map of:')
                         for t, v in asn1Spec.getPosMap().items():
-                            debug.logger('  %r -> %s' % (t, v.__class__.__name__))
+                            debug.logger('  {!r} -> {}'.format(t, v.__class__.__name__))
                         if asn1Spec.getNegMap():
                             debug.logger('but neither of: ')
                             for i in asn1Spec.getNegMap().items():
-                                debug.logger('  %r -> %s' % (t, v.__class__.__name__))
-                        debug.logger('new candidate ASN.1 spec is %s, chosen by %r' % (__chosenSpec is None and '<none>' or __chosenSpec.__class__.__name__, tagSet))
+                                debug.logger('  {!r} -> {}'.format(t, v.__class__.__name__))
+                        debug.logger('new candidate ASN.1 spec is {}, chosen by {!r}'.format(__chosenSpec is None and '<none>' or __chosenSpec.__class__.__name__, tagSet))
                 else:
                     __chosenSpec = asn1Spec
                     debug.logger and debug.logger & debug.flagDecoder and debug.logger('candidate ASN.1 spec is %s' % asn1Spec.__class__.__name__)
@@ -741,11 +741,11 @@ class Decoder:
                            __chosenSpec.typeId in self.__typeMap:
                         # ambiguous type
                         concreteDecoder = self.__typeMap[__chosenSpec.typeId]
-                        debug.logger and debug.logger & debug.flagDecoder and debug.logger('value decoder chosen for an ambiguous type by type ID %s' % (__chosenSpec.typeId,))
+                        debug.logger and debug.logger & debug.flagDecoder and debug.logger('value decoder chosen for an ambiguous type by type ID {}'.format(__chosenSpec.typeId))
                     elif baseTagSet in self.__tagMap:
                         # base type or tagged subtype
                         concreteDecoder = self.__tagMap[baseTagSet]
-                        debug.logger and debug.logger & debug.flagDecoder and debug.logger('value decoder chosen by base %r' % (baseTagSet,))
+                        debug.logger and debug.logger & debug.flagDecoder and debug.logger('value decoder chosen by base {!r}'.format(baseTagSet))
                     else:
                         concreteDecoder = None
                     if concreteDecoder:
@@ -761,7 +761,7 @@ class Decoder:
                     concreteDecoder = None
                     state = stTryAsExplicitTag
                 if debug.logger and debug.logger & debug.flagDecoder:
-                    debug.logger('codec %s chosen by ASN.1 spec, decoding %s' % (state == stDecodeValue and concreteDecoder.__class__.__name__ or "<none>", state == stDecodeValue and 'value' or 'as explicit tag'))
+                    debug.logger('codec {} chosen by ASN.1 spec, decoding {}'.format(state == stDecodeValue and concreteDecoder.__class__.__name__ or "<none>", state == stDecodeValue and 'value' or 'as explicit tag'))
                     debug.scope.push(__chosenSpec is None and '?' or __chosenSpec.__class__.__name__)
             if state == stTryAsExplicitTag:
                 if tagSet and \
@@ -773,7 +773,7 @@ class Decoder:
                 else:                    
                     concreteDecoder = None
                     state = self.defaultErrorState
-                debug.logger and debug.logger & debug.flagDecoder and debug.logger('codec %s chosen, decoding %s' % (concreteDecoder and concreteDecoder.__class__.__name__ or "<none>", state == stDecodeValue and 'value' or 'as failure'))
+                debug.logger and debug.logger & debug.flagDecoder and debug.logger('codec {} chosen, decoding {}'.format(concreteDecoder and concreteDecoder.__class__.__name__ or "<none>", state == stDecodeValue and 'value' or 'as failure'))
             if state == stDumpRawValue:
                 concreteDecoder = self.defaultRawDecoder
                 debug.logger and debug.logger & debug.flagDecoder and debug.logger('codec %s chosen, decoding value' % concreteDecoder.__class__.__name__)
@@ -792,10 +792,10 @@ class Decoder:
                         stGetValueDecoder, self, substrateFun
                         )
                 state = stStop
-                debug.logger and debug.logger & debug.flagDecoder and debug.logger('codec %s yields type %s, value:\n%s\n...remaining substrate is: %s' % (concreteDecoder.__class__.__name__, value.__class__.__name__, value.prettyPrint(), substrate and debug.hexdump(substrate) or '<none>'))
+                debug.logger and debug.logger & debug.flagDecoder and debug.logger('codec {} yields type {}, value:\n{}\n...remaining substrate is: {}'.format(concreteDecoder.__class__.__name__, value.__class__.__name__, value.prettyPrint(), substrate and debug.hexdump(substrate) or '<none>'))
             if state == stErrorCondition:
                 raise error.PyAsn1Error(
-                    '%r not in asn1Spec: %r' % (tagSet, asn1Spec)
+                    '{!r} not in asn1Spec: {!r}'.format(tagSet, asn1Spec)
                     )
         if debug.logger and debug.logger & debug.flagDecoder:
             debug.scope.pop()
diff --git a/python/pyasn1/pyasn1/codec/ber/encoder.py b/python/pyasn1/pyasn1/codec/ber/encoder.py
index 173949d0b6..7e5c7129a4 100644
--- a/python/pyasn1/pyasn1/codec/ber/encoder.py
+++ b/python/pyasn1/pyasn1/codec/ber/encoder.py
@@ -164,12 +164,12 @@ class ObjectIdentifierEncoder(AbstractItemEncoder):
             index = 5
         else:
             if len(oid) < 2:
-                raise error.PyAsn1Error('Short OID %s' % (value,))
+                raise error.PyAsn1Error('Short OID {}'.format(value))
 
             # Build the first twos
             if oid[0] > 6 or oid[1] > 39 or oid[0] == 6 and oid[1] > 15:
                 raise error.PyAsn1Error(
-                    'Initial sub-ID overflow %s in OID %s' % (oid[:2], value)
+                    'Initial sub-ID overflow {} in OID {}'.format(oid[:2], value)
                     )
             octets = (oid[0] * 40 + oid[1],)
             index = 2
@@ -181,7 +181,7 @@ class ObjectIdentifierEncoder(AbstractItemEncoder):
                 octets = octets + (subid & 0x7f,)
             elif subid < 0 or subid > 0xFFFFFFFF:
                 raise error.PyAsn1Error(
-                    'SubId overflow %s in %s' % (subid, value)
+                    'SubId overflow {} in {}'.format(subid, value)
                     )
             else:
                 # Pack large Sub-Object IDs
@@ -328,7 +328,7 @@ class Encoder:
         self.__typeMap = typeMap
 
     def __call__(self, value, defMode=1, maxChunkSize=0):
-        debug.logger & debug.flagEncoder and debug.logger('encoder called in %sdef mode, chunk size %s for type %s, value:\n%s' % (not defMode and 'in' or '', maxChunkSize, value.__class__.__name__, value.prettyPrint()))
+        debug.logger & debug.flagEncoder and debug.logger('encoder called in {}def mode, chunk size {} for type {}, value:\n{}'.format(not defMode and 'in' or '', maxChunkSize, value.__class__.__name__, value.prettyPrint()))
         tagSet = value.getTagSet()
         if len(tagSet) > 1:
             concreteEncoder = explicitlyTaggedItemEncoder
@@ -342,12 +342,12 @@ class Encoder:
                 if tagSet in self.__tagMap:
                     concreteEncoder = self.__tagMap[tagSet]
                 else:
-                    raise Error('No encoder for %s' % (value,))
-        debug.logger & debug.flagEncoder and debug.logger('using value codec %s chosen by %r' % (concreteEncoder.__class__.__name__, tagSet))
+                    raise Error('No encoder for {}'.format(value))
+        debug.logger & debug.flagEncoder and debug.logger('using value codec {} chosen by {!r}'.format(concreteEncoder.__class__.__name__, tagSet))
         substrate = concreteEncoder.encode(
             self, value, defMode, maxChunkSize
             )
-        debug.logger & debug.flagEncoder and debug.logger('built %s octets of substrate: %s\nencoder completed' % (len(substrate), debug.hexdump(substrate)))
+        debug.logger & debug.flagEncoder and debug.logger('built {} octets of substrate: {}\nencoder completed'.format(len(substrate), debug.hexdump(substrate)))
         return substrate
 
 encode = Encoder(tagMap, typeMap)
diff --git a/python/pyasn1/pyasn1/debug.py b/python/pyasn1/pyasn1/debug.py
index c27cb1d446..080fb1700d 100644
--- a/python/pyasn1/pyasn1/debug.py
+++ b/python/pyasn1/pyasn1/debug.py
@@ -22,12 +22,12 @@ class Debug:
         self('running pyasn1 version %s' % __version__)
         for f in flags:
             if f not in flagMap:
-                raise error.PyAsn1Error('bad debug flag %s' % (f,))
+                raise error.PyAsn1Error('bad debug flag {}'.format(f))
             self._flags = self._flags | flagMap[f]
             self('debug category \'%s\' enabled' % f)
         
     def __str__(self):
-        return 'logger %s, flags %x' % (self._printer, self._flags)
+        return 'logger {}, flags {:x}'.format(self._printer, self._flags)
     
     def __call__(self, msg):
         self._printer('DBG: %s\n' % msg)
@@ -46,8 +46,8 @@ def setLogger(l):
 
 def hexdump(octets):
     return ' '.join(
-            [ '%s%.2X' % (n%16 == 0 and ('\n%.5d: ' % n) or '', x) 
-              for n,x in zip(range(len(octets)), octs2ints(octets)) ]
+            [ '{}{:.2X}'.format(n%16 == 0 and ('\n%.5d: ' % n) or '', x) 
+              for n,x in zip(list(range(len(octets))), octs2ints(octets)) ]
         )
 
 class Scope:
diff --git a/python/pyasn1/pyasn1/type/base.py b/python/pyasn1/pyasn1/type/base.py
index 40873719ca..9391b85eb6 100644
--- a/python/pyasn1/pyasn1/type/base.py
+++ b/python/pyasn1/pyasn1/type/base.py
@@ -30,7 +30,7 @@ class Asn1ItemBase(Asn1Item):
             self._subtypeSpec(value, idx)
         except error.PyAsn1Error:
             c, i, t = sys.exc_info()
-            raise c('%s at %s' % (i, self.__class__.__name__))
+            raise c('{} at {}'.format(i, self.__class__.__name__))
         
     def getSubtypeSpec(self): return self._subtypeSpec
     
@@ -75,7 +75,7 @@ class AbstractSimpleAsn1Item(Asn1ItemBase):
         if self._value is noValue:
             return self.__class__.__name__ + '()'
         else:
-            return self.__class__.__name__ + '(%s)' % (self.prettyOut(self._value),)
+            return self.__class__.__name__ + '({})'.format(self.prettyOut(self._value))
     def __str__(self): return str(self._value)
     def __eq__(self, other):
         return self is other and True or self._value == other
@@ -170,7 +170,7 @@ class AbstractConstructedAsn1Item(Asn1ItemBase):
         for idx in range(len(self._componentValues)):
             if self._componentValues[idx] is None:
                 continue
-            r = r + '.setComponentByPosition(%s, %r)' % (
+            r = r + '.setComponentByPosition({}, {!r})'.format(
                 idx, self._componentValues[idx]
                 )
         return r
diff --git a/python/pyasn1/pyasn1/type/constraint.py b/python/pyasn1/pyasn1/type/constraint.py
index 66873937d8..a02c37eaf9 100644
--- a/python/pyasn1/pyasn1/type/constraint.py
+++ b/python/pyasn1/pyasn1/type/constraint.py
@@ -29,10 +29,10 @@ class AbstractConstraint:
             self._testValue(value, idx)
         except error.ValueConstraintError:
             raise error.ValueConstraintError(
-               '%s failed at: \"%s\"' % (self, sys.exc_info()[1])
+               '{} failed at: \"{}\"'.format(self, sys.exc_info()[1])
             )
     def __repr__(self):
-        return '%s(%s)' % (
+        return '{}({})'.format(
             self.__class__.__name__,
             ', '.join([repr(x) for x in self._values])
         )
@@ -88,12 +88,12 @@ class ValueRangeConstraint(AbstractConstraint):
     def _setValues(self, values):
         if len(values) != 2:
             raise error.PyAsn1Error(
-                '%s: bad constraint values' % (self.__class__.__name__,)
+                '{}: bad constraint values'.format(self.__class__.__name__)
                 )
         self.start, self.stop = values
         if self.start > self.stop:
             raise error.PyAsn1Error(
-                '%s: screwed constraint values (start > stop): %s > %s' % (
+                '{}: screwed constraint values (start > stop): {} > {}'.format(
                     self.__class__.__name__,
                     self.start, self.stop
                 )
@@ -193,7 +193,7 @@ class ConstraintsUnion(AbstractConstraintSet):
             else:
                 return
         raise error.ValueConstraintError(
-            'all of %s failed for \"%s\"' % (self._values, value)
+            'all of {} failed for \"{}\"'.format(self._values, value)
             )
 
 # XXX
diff --git a/python/pyasn1/pyasn1/type/namedtype.py b/python/pyasn1/pyasn1/type/namedtype.py
index 48967a5fe2..b18ad30db5 100644
--- a/python/pyasn1/pyasn1/type/namedtype.py
+++ b/python/pyasn1/pyasn1/type/namedtype.py
@@ -8,7 +8,7 @@ class NamedType:
     isDefaulted = 0
     def __init__(self, name, t):
         self.__name = name; self.__type = t
-    def __repr__(self): return '%s(%s, %s)' % (
+    def __repr__(self): return '{}({}, {})'.format(
         self.__class__.__name__, self.__name, self.__type
         )
     def getType(self): return self.__type
@@ -35,7 +35,7 @@ class NamedTypes:
     def __repr__(self):
         r = '%s(' % self.__class__.__name__
         for n in self.__namedTypes:
-            r = r + '%r, ' % (n,)
+            r = r + '{!r}, '.format(n)
         return r + ')'
     
     def __getitem__(self, idx): return self.__namedTypes[idx]
@@ -60,12 +60,12 @@ class NamedTypes:
                 tagMap = self.__namedTypes[idx].getType().getTagMap()
                 for t in tagMap.getPosMap():
                     if t in self.__tagToPosIdx:
-                        raise error.PyAsn1Error('Duplicate type %s' % (t,))
+                        raise error.PyAsn1Error('Duplicate type {}'.format(t))
                     self.__tagToPosIdx[t] = idx
         try:
             return self.__tagToPosIdx[tagSet]
         except KeyError:
-            raise error.PyAsn1Error('Type %s not found' % (tagSet,))
+            raise error.PyAsn1Error('Type {} not found'.format(tagSet))
         
     def getNameByPosition(self, idx):
         try:
@@ -79,12 +79,12 @@ class NamedTypes:
                 idx = idx - 1
                 n = self.__namedTypes[idx].getName()
                 if n in self.__nameToPosIdx:
-                    raise error.PyAsn1Error('Duplicate name %s' % (n,))
+                    raise error.PyAsn1Error('Duplicate name {}'.format(n))
                 self.__nameToPosIdx[n] = idx
         try:
             return self.__nameToPosIdx[name]
         except KeyError:
-            raise error.PyAsn1Error('Name %s not found' % (name,))
+            raise error.PyAsn1Error('Name {} not found'.format(name))
 
     def __buildAmbigiousTagMap(self):
         ambigiousTypes = ()
diff --git a/python/pyasn1/pyasn1/type/namedval.py b/python/pyasn1/pyasn1/type/namedval.py
index d0fea7cc7c..26267eb1df 100644
--- a/python/pyasn1/pyasn1/type/namedval.py
+++ b/python/pyasn1/pyasn1/type/namedval.py
@@ -15,10 +15,10 @@ class NamedValues:
                 name = namedValue
                 val = automaticVal
             if name in self.nameToValIdx:
-                raise error.PyAsn1Error('Duplicate name %s' % (name,))
+                raise error.PyAsn1Error('Duplicate name {}'.format(name))
             self.nameToValIdx[name] = val
             if val in self.valToNameIdx:
-                raise error.PyAsn1Error('Duplicate value %s=%s' % (name, val))
+                raise error.PyAsn1Error('Duplicate value {}={}'.format(name, val))
             self.valToNameIdx[val] = name
             self.namedValues = self.namedValues + ((name, val),)
             automaticVal = automaticVal + 1
diff --git a/python/pyasn1/pyasn1/type/tag.py b/python/pyasn1/pyasn1/type/tag.py
index 1144907fa1..17122a59c3 100644
--- a/python/pyasn1/pyasn1/type/tag.py
+++ b/python/pyasn1/pyasn1/type/tag.py
@@ -18,7 +18,7 @@ class Tag:
     def __init__(self, tagClass, tagFormat, tagId):
         if tagId < 0:
             raise error.PyAsn1Error(
-                'Negative tag ID (%s) not allowed' % (tagId,)
+                'Negative tag ID ({}) not allowed'.format(tagId)
                 )
         self.__tag = (tagClass, tagFormat, tagId)
         self.uniq = (tagClass, tagId)
@@ -64,7 +64,7 @@ class TagSet:
         self.__lenOfSuperTags = len(superTags)
         
     def __repr__(self):
-        return '%s(%s)' % (
+        return '{}({})'.format(
             self.__class__.__name__,
             ', '.join([repr(x) for x in self.__superTags])
             )
